package sk.seges.sesam.core.test.selenium.configuration.annotation;

import java.io.PrintStream;

import javax.annotation.Generated;

import sk.seges.sesam.core.configuration.annotation.Settings;
import sk.seges.sesam.core.configuration.api.ConfigurationValue;
import sk.seges.sesam.core.configuration.utils.ConfigurationUtils;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.HtmlReport;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.Screenshot;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.Screenshot.After;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.Screenshot.Before;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.Screenshot.When;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Report.Support;
import sk.seges.sesam.core.test.selenium.configuration.annotation.ReportSettings.HtmlReportSettings;
import sk.seges.sesam.core.test.selenium.configuration.annotation.ReportSettings.ScreenshotSettings;
import sk.seges.sesam.core.test.selenium.configuration.annotation.ReportSettings.ScreenshotSettings.AfterSettings;
import sk.seges.sesam.core.test.selenium.configuration.annotation.ReportSettings.ScreenshotSettings.BeforeSettings;
import sk.seges.sesam.core.test.selenium.configuration.annotation.ReportSettings.SupportSettings;
import sk.seges.sesam.core.test.selenium.report.model.SeleniumOperation;

@Settings(configuration = Report.class)
@Generated(value = "sk.seges.sesam.pap.configuration.processor.SettingsProcessor")
public class ReportSettings {

	@Settings(configuration = HtmlReport.class)
	public static class HtmlReportSettings {
		private String locale;

		private String suiteTemplatePath;

		private SupportSettings support;

		private String testTemplatePath;

		/**
		* Defines locale for the generated report
		*/
		public String getLocale() {
			return locale;
		}
		
		public void setLocale(String locale) {
			this.locale = locale;
		}
		
		/**
		* Defines path to the used template for suite
		*/
		public String getSuiteTemplatePath() {
			return suiteTemplatePath;
		}
		
		public void setSuiteTemplatePath(String suiteTemplatePath) {
			this.suiteTemplatePath = suiteTemplatePath;
		}
		
		public SupportSettings getSupport() {
			return support;
		}
		
		public void setSupport(SupportSettings support) {
			this.support = support;
		}
		
		/**
		* Defines path to the used template for tests
		*/
		public String getTestTemplatePath() {
			return testTemplatePath;
		}
		
		public void setTestTemplatePath(String testTemplatePath) {
			this.testTemplatePath = testTemplatePath;
		}
		
		public HtmlReportSettings(ConfigurationValue[] configurations) {
			this.locale = ConfigurationUtils.getConfigurationValue(configurations, "suite.template.locale");
			this.suiteTemplatePath = ConfigurationUtils.getConfigurationValue(configurations, "suite.template.path");
			this.support = new SupportSettings(configurations);
			this.testTemplatePath = ConfigurationUtils.getConfigurationValue(configurations, "test.template.path");
		}

		public HtmlReportSettings(String locale, String suiteTemplatePath, SupportSettings support, String testTemplatePath) {
			this.locale = locale;
			this.suiteTemplatePath = suiteTemplatePath;
			this.support = support;
			this.testTemplatePath = testTemplatePath;
		}

		public HtmlReportSettings(HtmlReportSettings htmlReportSettings) {
			this.locale = htmlReportSettings.getLocale();
			this.suiteTemplatePath = htmlReportSettings.getSuiteTemplatePath();
			this.support = htmlReportSettings.getSupport();
			this.testTemplatePath = htmlReportSettings.getTestTemplatePath();
		}

		public HtmlReportSettings merge(HtmlReportSettings htmlReportSettings) {
			if (htmlReportSettings == null) {
				return this;
			}
			if (locale == null) {
				this.locale = htmlReportSettings.getLocale();
			}
			if (suiteTemplatePath == null) {
				this.suiteTemplatePath = htmlReportSettings.getSuiteTemplatePath();
			}
			if (support == null) {
				this.support = htmlReportSettings.getSupport();
			} else {
				this.support.merge(htmlReportSettings.getSupport());
			}
			if (testTemplatePath == null) {
				this.testTemplatePath = htmlReportSettings.getTestTemplatePath();
			}
			return this;
		}

		public void printHelp(PrintStream out) {
			printHelp(out, "", null);
		}

		public void printHelp(PrintStream out, String prefix, String name) {
			out.format("%-50s Defines locale for the generated report" + (name != null ? " for " + name : "") + "\n", prefix + "suite.template.locale");
			out.format("%-50s Defines path to the used template for suite" + (name != null ? " for " + name : "") + "\n", prefix + "suite.template.path");
			support.printHelp(out, prefix + "report.html.", "HTML reports");
			out.format("%-50s Defines path to the used template for tests" + (name != null ? " for " + name : "") + "\n", prefix + "test.template.path");
		}
	}
	@Settings(configuration = Screenshot.class)
	public static class ScreenshotSettings {
		@Settings(configuration = After.class)
		public static class AfterSettings {
			private SeleniumOperation[] value;

			/**
			* operations
			*/
			public SeleniumOperation[] getValue() {
				return value;
			}
			
			public void setValue(SeleniumOperation[] value) {
				this.value = value;
			}
			
			public AfterSettings(ConfigurationValue[] configurations) {
				String[] _value = ConfigurationUtils.getConfigurationValues(configurations, "operations");
				if (_value.length > 0) {
					this.value = new SeleniumOperation[_value.length];
					for (int i = 0; i < _value.length; i++) {
						for (SeleniumOperation _enumValue: SeleniumOperation.values()) {
							if (_enumValue.toString().equals(_value[i])) {
								this.value[i] = _enumValue;
							}
						}
					}
				}
			}

			public AfterSettings(SeleniumOperation[] value) {
				this.value = value;
			}

			public AfterSettings(AfterSettings afterSettings) {
				this.value = afterSettings.getValue();
			}

			public AfterSettings merge(AfterSettings afterSettings) {
				if (afterSettings == null) {
					return this;
				}
				if (value == null) {
					this.value = afterSettings.getValue();
				}
				return this;
			}

			public void printHelp(PrintStream out) {
				printHelp(out, "", null);
			}

			public void printHelp(PrintStream out, String prefix, String name) {
				out.format("%-50s operations" + (name != null ? " for " + name : "") + "\n", prefix + "operations");
			}
		}
		@Settings(configuration = Before.class)
		public static class BeforeSettings {
			private SeleniumOperation[] value;

			/**
			* operations
			*/
			public SeleniumOperation[] getValue() {
				return value;
			}
			
			public void setValue(SeleniumOperation[] value) {
				this.value = value;
			}
			
			public BeforeSettings(ConfigurationValue[] configurations) {
				String[] _value = ConfigurationUtils.getConfigurationValues(configurations, "operations");
				if (_value.length > 0) {
					this.value = new SeleniumOperation[_value.length];
					for (int i = 0; i < _value.length; i++) {
						for (SeleniumOperation _enumValue: SeleniumOperation.values()) {
							if (_enumValue.toString().equals(_value[i])) {
								this.value[i] = _enumValue;
							}
						}
					}
				}
			}

			public BeforeSettings(SeleniumOperation[] value) {
				this.value = value;
			}

			public BeforeSettings(BeforeSettings beforeSettings) {
				this.value = beforeSettings.getValue();
			}

			public BeforeSettings merge(BeforeSettings beforeSettings) {
				if (beforeSettings == null) {
					return this;
				}
				if (value == null) {
					this.value = beforeSettings.getValue();
				}
				return this;
			}

			public void printHelp(PrintStream out) {
				printHelp(out, "", null);
			}

			public void printHelp(PrintStream out, String prefix, String name) {
				out.format("%-50s operations" + (name != null ? " for " + name : "") + "\n", prefix + "operations");
			}
		}
		private AfterSettings after;

		private BeforeSettings before;

		private SupportSettings support;

		private When[] when;

		public AfterSettings getAfter() {
			return after;
		}
		
		public void setAfter(AfterSettings after) {
			this.after = after;
		}
		
		public BeforeSettings getBefore() {
			return before;
		}
		
		public void setBefore(BeforeSettings before) {
			this.before = before;
		}
		
		public SupportSettings getSupport() {
			return support;
		}
		
		public void setSupport(SupportSettings support) {
			this.support = support;
		}
		
		/**
		* on 
		*/
		public When[] getWhen() {
			return when;
		}
		
		public void setWhen(When[] when) {
			this.when = when;
		}
		
		public ScreenshotSettings(ConfigurationValue[] configurations) {
			this.after = new AfterSettings(configurations);
			this.before = new BeforeSettings(configurations);
			this.support = new SupportSettings(configurations);
			String[] _when = ConfigurationUtils.getConfigurationValues(configurations, "when");
			if (_when.length > 0) {
				this.when = new When[_when.length];
				for (int i = 0; i < _when.length; i++) {
					for (When _enumValue: When.values()) {
						if (_enumValue.toString().equals(_when[i])) {
							this.when[i] = _enumValue;
						}
					}
				}
			}
		}

		public ScreenshotSettings(AfterSettings after, BeforeSettings before, SupportSettings support, When[] when) {
			this.after = after;
			this.before = before;
			this.support = support;
			this.when = when;
		}

		public ScreenshotSettings(ScreenshotSettings screenshotSettings) {
			this.after = screenshotSettings.getAfter();
			this.before = screenshotSettings.getBefore();
			this.support = screenshotSettings.getSupport();
			this.when = screenshotSettings.getWhen();
		}

		public ScreenshotSettings merge(ScreenshotSettings screenshotSettings) {
			if (screenshotSettings == null) {
				return this;
			}
			if (after == null) {
				this.after = screenshotSettings.getAfter();
			} else {
				this.after.merge(screenshotSettings.getAfter());
			}
			if (before == null) {
				this.before = screenshotSettings.getBefore();
			} else {
				this.before.merge(screenshotSettings.getBefore());
			}
			if (support == null) {
				this.support = screenshotSettings.getSupport();
			} else {
				this.support.merge(screenshotSettings.getSupport());
			}
			if (when == null) {
				this.when = screenshotSettings.getWhen();
			}
			return this;
		}

		public void printHelp(PrintStream out) {
			printHelp(out, "", null);
		}

		public void printHelp(PrintStream out, String prefix, String name) {
			after.printHelp(out, prefix + "after.", "after specified");
			before.printHelp(out, prefix + "before.", "before specified");
			support.printHelp(out, prefix + "support.", "Screenshot reports");
			out.format("%-50s on " + (name != null ? " for " + name : "") + "\n", prefix + "when");
		}
	}
	@Settings(configuration = Support.class)
	public static class SupportSettings {
		private String directory;

		private Boolean enabled;

		/**
		* Output directory
		*/
		public String getDirectory() {
			return directory;
		}
		
		public void setDirectory(String directory) {
			this.directory = directory;
		}
		
		/**
		* Enables/disables support
		*/
		public Boolean getEnabled() {
			return enabled;
		}
		
		public void setEnabled(Boolean enabled) {
			this.enabled = enabled;
		}
		
		public SupportSettings(ConfigurationValue[] configurations) {
			this.directory = ConfigurationUtils.getConfigurationValue(configurations, "directory");
			this.enabled = ConfigurationUtils.getConfigurationBoolean(configurations, "enabled");
		}

		public SupportSettings(String directory, Boolean enabled) {
			this.directory = directory;
			this.enabled = enabled;
		}

		public SupportSettings(SupportSettings supportSettings) {
			this.directory = supportSettings.getDirectory();
			this.enabled = supportSettings.getEnabled();
		}

		public SupportSettings merge(SupportSettings supportSettings) {
			if (supportSettings == null) {
				return this;
			}
			if (directory == null) {
				this.directory = supportSettings.getDirectory();
			}
			if (enabled == null) {
				this.enabled = supportSettings.getEnabled();
			}
			return this;
		}

		public void printHelp(PrintStream out) {
			printHelp(out, "", null);
		}

		public void printHelp(PrintStream out, String prefix, String name) {
			out.format("%-50s Output directory" + (name != null ? " for " + name : "") + "\n", prefix + "directory");
			out.format("%-50s Enables/disables support" + (name != null ? " for " + name : "") + "\n", prefix + "enabled");
		}
	}
	private HtmlReportSettings html;

	private ScreenshotSettings screenshot;

	public HtmlReportSettings getHtml() {
		return html;
	}
	
	public void setHtml(HtmlReportSettings html) {
		this.html = html;
	}
	
	public ScreenshotSettings getScreenshot() {
		return screenshot;
	}
	
	public void setScreenshot(ScreenshotSettings screenshot) {
		this.screenshot = screenshot;
	}
	
	public ReportSettings(ConfigurationValue[] configurations) {
		this.html = new HtmlReportSettings(configurations);
		this.screenshot = new ScreenshotSettings(configurations);
	}

	public ReportSettings(HtmlReportSettings html, ScreenshotSettings screenshot) {
		this.html = html;
		this.screenshot = screenshot;
	}

	public ReportSettings(ReportSettings reportSettings) {
		this.html = reportSettings.getHtml();
		this.screenshot = reportSettings.getScreenshot();
	}

	public ReportSettings merge(ReportSettings reportSettings) {
		if (reportSettings == null) {
			return this;
		}
		if (html == null) {
			this.html = reportSettings.getHtml();
		} else {
			this.html.merge(reportSettings.getHtml());
		}
		if (screenshot == null) {
			this.screenshot = reportSettings.getScreenshot();
		} else {
			this.screenshot.merge(reportSettings.getScreenshot());
		}
		return this;
	}

	public void printHelp(PrintStream out) {
		printHelp(out, "", null);
	}

	public void printHelp(PrintStream out, String prefix, String name) {
		html.printHelp(out, prefix + "report.html.", "HTML reports");
		screenshot.printHelp(out, prefix + "report.screenshot.", "Defines that screenshot is taken");
	}
}