package sk.seges.sesam.core.test.selenium.configuration.annotation;

import java.io.PrintStream;

import javax.annotation.Generated;

import sk.seges.sesam.core.configuration.annotation.Settings;
import sk.seges.sesam.core.configuration.api.ConfigurationValue;
import sk.seges.sesam.core.configuration.utils.ConfigurationUtils;
import sk.seges.sesam.core.test.selenium.configuration.api.Browsers;

@Settings(configuration = Selenium.class)
@Generated(value = "sk.seges.sesam.pap.configuration.processor.SettingsProcessor")
public class SeleniumSettings {

	private Browsers browser;

	private Integer seleniumPort;

	private Boolean seleniumRemote;

	private String seleniumServer;

	private String testURI;

	private String testURL;

	/**
	* Defines browser the tests are executed with.
	*/
	public Browsers getBrowser() {
		return browser;
	}
	
	public void setBrowser(Browsers browser) {
		this.browser = browser;
	}
	
	/**
	* Defines port name where the selenium server is located.
	*/
	public Integer getSeleniumPort() {
		return seleniumPort;
	}
	
	public void setSeleniumPort(Integer seleniumPort) {
		this.seleniumPort = seleniumPort;
	}
	
	/**
	* Bindings connect to the remote server instance.
	*/
	public Boolean getSeleniumRemote() {
		return seleniumRemote;
	}
	
	public void setSeleniumRemote(Boolean seleniumRemote) {
		this.seleniumRemote = seleniumRemote;
	}
	
	/**
	* Defines host name where the selenium server is located.
	*/
	public String getSeleniumServer() {
		return seleniumServer;
	}
	
	public void setSeleniumServer(String seleniumServer) {
		this.seleniumServer = seleniumServer;
	}
	
	/**
	* Defines relative URI of the testing home page.
	*/
	public String getTestURI() {
		return testURI;
	}
	
	public void setTestURI(String testURI) {
		this.testURI = testURI;
	}
	
	/**
	* Defines root URL of the testing site.
	*/
	public String getTestURL() {
		return testURL;
	}
	
	public void setTestURL(String testURL) {
		this.testURL = testURL;
	}
	
	public SeleniumSettings(ConfigurationValue[] configurations) {
		String _browser = ConfigurationUtils.getConfigurationValue(configurations, "test.testBrowser");
		for (Browsers _enumValue: Browsers.values()) {
			if (_enumValue.toString().equals(_browser)) {
				this.browser = _enumValue;
			}
		}
		this.seleniumPort = ConfigurationUtils.getConfigurationInt(configurations, "test.seleniumPort");
		this.seleniumRemote = ConfigurationUtils.getConfigurationBoolean(configurations, "test.testRemote");
		this.seleniumServer = ConfigurationUtils.getConfigurationValue(configurations, "test.seleniumHost");
		this.testURI = ConfigurationUtils.getConfigurationValue(configurations, "test.testUri");
		this.testURL = ConfigurationUtils.getConfigurationValue(configurations, "test.testHost");
	}

	public SeleniumSettings(Browsers browser, Integer seleniumPort, Boolean seleniumRemote, String seleniumServer, String testURI, String testURL) {
		this.browser = browser;
		this.seleniumPort = seleniumPort;
		this.seleniumRemote = seleniumRemote;
		this.seleniumServer = seleniumServer;
		this.testURI = testURI;
		this.testURL = testURL;
	}

	public SeleniumSettings(SeleniumSettings seleniumSettings) {
		this.browser = seleniumSettings.getBrowser();
		this.seleniumPort = seleniumSettings.getSeleniumPort();
		this.seleniumRemote = seleniumSettings.getSeleniumRemote();
		this.seleniumServer = seleniumSettings.getSeleniumServer();
		this.testURI = seleniumSettings.getTestURI();
		this.testURL = seleniumSettings.getTestURL();
	}

	public SeleniumSettings merge(SeleniumSettings seleniumSettings) {
		if (seleniumSettings == null) {
			return this;
		}
		if (browser == null) {
			this.browser = seleniumSettings.getBrowser();
		}
		if (seleniumPort == null) {
			this.seleniumPort = seleniumSettings.getSeleniumPort();
		}
		if (seleniumRemote == null) {
			this.seleniumRemote = seleniumSettings.getSeleniumRemote();
		}
		if (seleniumServer == null) {
			this.seleniumServer = seleniumSettings.getSeleniumServer();
		}
		if (testURI == null) {
			this.testURI = seleniumSettings.getTestURI();
		}
		if (testURL == null) {
			this.testURL = seleniumSettings.getTestURL();
		}
		return this;
	}

	public void printHelp(PrintStream out) {
		printHelp(out, "", null);
	}

	public void printHelp(PrintStream out, String prefix, String name) {
		out.format("%-50s Defines browser the tests are executed with." + (name != null ? " for " + name : "") + "\n", prefix + "test.testBrowser");
		out.format("%-50s Possible values: " + Browsers.FIREFOX.toString() + ","  + Browsers.IE.toString() + ","  + Browsers.SAFARI.toString() + ","  + Browsers.OPERA.toString() + ","  + Browsers.CHROME.toString() + ","  + Browsers.HTML_UNIT.toString() + "\n", "");
		out.format("%-50s Defines port name where the selenium server is located." + (name != null ? " for " + name : "") + "\n", prefix + "test.seleniumPort");
		out.format("%-50s Bindings connect to the remote server instance." + (name != null ? " for " + name : "") + "\n", prefix + "test.testRemote");
		out.format("%-50s Defines host name where the selenium server is located." + (name != null ? " for " + name : "") + "\n", prefix + "test.seleniumHost");
		out.format("%-50s Defines relative URI of the testing home page." + (name != null ? " for " + name : "") + "\n", prefix + "test.testUri");
		out.format("%-50s Defines root URL of the testing site." + (name != null ? " for " + name : "") + "\n", prefix + "test.testHost");
	}
}